package saces.app;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.PrintWriter;
import java.io.StringWriter;


class UncaughtExceptionHandler
    implements Thread.UncaughtExceptionHandler, ActionListener {

public void actionPerformed(ActionEvent e) {
    JButton source = ((JButton)e.getSource());

    if (source.getText().equals("Exit"))
        System.exit(1);
    if (source.getText().equals("Continue"))
        source.getTopLevelAncestor().setVisible(false);
}

public void uncaughtException(Thread t, Throwable e) {
    e.printStackTrace();

    final JFrame f = new JFrame("Internal Error");

    JPanel pp1 = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pp1.setBorder(BorderFactory.createMatteBorder(5, 5, 5, 5, Color.black));

    JLabel l = new JLabel("<html><center>"
        + "<h3>An internal error has been discovered.</h4>"
        + "<h4>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
        + "'saces' is beta-quality software and may have many bugs."
        + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>"
        + "We are sorry for any inconvenience.<br><br>"
        + "You can try to continue, but be warned of<br>"
        + "inconsistencies or erratic behaviour or<br>"
        + "outright crashes.</h4>"
        + "Below there's a copy of the Java stack trace "
        + "(useful for debugging)</center>");

    l.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
    pp1.add(l);

    JPanel pp2 = new JPanel();
    pp2.setBorder(BorderFactory.createEmptyBorder(0, 0, 5, 0));
    pp2.add(pp1, BorderLayout.CENTER);

    StringWriter sw = new StringWriter();
    e.printStackTrace(new PrintWriter(sw));
    JTextArea jta = new JTextArea(sw.toString());
    JScrollPane jsp = new JScrollPane(jta,
        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
        JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

    JPanel pp3 = new JPanel(new FlowLayout(FlowLayout.CENTER));
    JButton b1 = new JButton("Exit");
    b1.addActionListener(this);
    JButton b2 = new JButton("Continue");
    b2.addActionListener(this);
    pp3.add(b1);
    pp3.add(b2);

    JPanel p = new JPanel(new BorderLayout());
    p.setBorder(BorderFactory.createEmptyBorder(5, 5, 0, 5));
    p.add(pp2, BorderLayout.NORTH);
    p.add(jsp, BorderLayout.CENTER);
    p.add(pp3, BorderLayout.SOUTH);

    f.getContentPane().add(p);
    f.setAlwaysOnTop(true);
    f.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
    f.setSize(600, 500);
    f.setVisible(true);
}
}
