/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.app.gui;

import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.util.LinkedList;


/** A small helper class to help ChangeEvent senders */
public class ChangeSupport {

private LinkedList<ChangeListener> listeners
    = new LinkedList<ChangeListener>();

public synchronized void addChangeListener(ChangeListener listener) {
    if (listener == null) throw new NullPointerException("listener");

    listeners.add(listener);
}

public synchronized void removeChangeListener(ChangeListener listener) {
    if (listener == null) throw new NullPointerException("listener");

    listeners.remove(listener);
}

public void fireStateChanged(Object source) {
    ChangeEvent changeEvent = new ChangeEvent(source);
    for (ChangeListener listener : listeners)
        listener.stateChanged(changeEvent);
}

}
