/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.app.gui;

import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.JTextField;


/** This class helps ensure that valid numbers are entered in some
 *  input text fields.
 */
public class NumberVerifier extends InputVerifier {

private float from;
private float to;
private boolean fromVerifier;
private boolean rangeVerifier;
private boolean integer;
private boolean empty;

public NumberVerifier() {
}

public NumberVerifier(boolean integer) {
    this.integer = integer;
}

public NumberVerifier(float from) {
    fromVerifier = true;
    this.from = from;
}

public NumberVerifier(float from, boolean integer) {
    this(integer);
    fromVerifier = true;
    this.from = from;
}

public NumberVerifier(float from, float to) {
    fromVerifier = rangeVerifier = true;
    this.from = from;
    this.to = to;
}

public NumberVerifier(float from, float to, boolean integer) {
    this(from, to);
    this.integer = integer;
}

public static NumberVerifier emptyAllowed(boolean integer) {
    NumberVerifier nv = new NumberVerifier(integer);
    nv.empty = true;
    return nv;
}

public boolean verify(JComponent input) {
    if (!(input instanceof JTextField)) return false;
    String text = ((JTextField)input).getText();

    if (empty && text.length() == 0) return true;
    float value;
    try {
        value = integer ? Integer.parseInt(text) : Float.parseFloat(text);
    }
    catch (NumberFormatException nfe) {
        return false;
    }

    if (fromVerifier && value < from) return false;
    if (rangeVerifier && value > to) return false;

    return true;
}
}
