/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.app.gui;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;


/** The toolbar for the settings dialog window. */
public class SettingsButtonPanel extends JToolBar {

private static final long serialVersionUID = 3691863843563825970L;
private Map<String, JButton> buttons = new HashMap<String, JButton>();

/** The action command for the Load... button. */
public static final String LOAD = "Load...";
/** The action command for the Save button. */
public static final String SAVE = "Save";
/** The action command for the Save as... button. */
public static final String SAVEAS = "Save as...";
/** The action command for the Start button. */
public static final String START = "Start";

public SettingsButtonPanel() {
    String[] labels = {LOAD, SAVE, SAVEAS, START};
    String[] img = {"load", "save", "save", "run"};

    setFloatable(false);
    setRollover(true);

    for (int i = 0; i < labels.length; i++) {
        URL url = getClass().getResource("img/" + img[i] + ".png");
        if (url == null) url = getClass().getResource("img/null.png");
        buttons.put(labels[i], new JButton(labels[i], new ImageIcon(url)));
        add(buttons.get(labels[i]));
    }
}

/**
 * Create a SettingsButtonPanel with an action listener to handle the actions
 * from the buttons.
 */
public SettingsButtonPanel(ActionListener actionListener) {
    this();
    addActionListener(actionListener);
}

/** Add actionlisteners to the toolbar buttons. */
public void addActionListener(ActionListener actionListener) {
    for (JButton button : buttons.values())
        button.addActionListener(actionListener);
}

/** Enable/Disable the button with key. */
public void setEnabled(String key, boolean enabled) {
    if (buttons.containsKey(key)) buttons.get(key).setEnabled(enabled);
}

}
