/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.app.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.font.TextAttribute;
import java.net.URL;
import java.text.AttributedString;


/** Creates a splash screen with version info */
public class SplashScreen extends Frame {

private final String imageName;
//private AttributedString attributedString;

/** Constructor */
public SplashScreen() {

    imageName = "../img/splash.png";
//    attributedString = new AttributedString("beta");
//    attributedString.addAttribute(TextAttribute.FONT, new Font("Lucia",
//        Font.PLAIN, 30));
//    attributedString.addAttribute(TextAttribute.FOREGROUND, Color.yellow);

}

/** Show the splash screen */
public void splash() {

    MediaTracker mediaTracker = new MediaTracker(this);
    URL imageURL = getClass().getResource(imageName);
    if (imageURL == null) {
        System.out.println("Image for splash screen not found");
        return;
    }

    Image image = Toolkit.getDefaultToolkit().getImage(imageURL);
    mediaTracker.addImage(image, 1);

    try {
        mediaTracker.waitForID(1);
    }
    catch (InterruptedException ie) {}

    new SplashWindow(this, image);
}

/** Window to display splash */
private class SplashWindow extends Window {

    SplashWindow(Frame aParent, Image image) {

        super(aParent);
        this.image = image;
        setSize(image.getWidth(null), image.getHeight(null));
        Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
        Rectangle window = getBounds();
        setLocation((screen.width - window.width) / 2,
            (screen.height - window.height) / 2);

        setVisible(true);
    }

    /** Paints the spash screen */
    public void paint(Graphics graphics) {
        if (image != null) {
            Graphics2D g2D = (Graphics2D)graphics;
            g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
            g2D.drawImage(image, 0, 0, this);
//            g2D.drawString(attributedString.getIterator(), 250, 130);
        }
    }

    private Image image;
}

}
