/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.app.gui;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

// Warning: Some duplicate code with ApplicationButtonPanel

/** A toolbar for the view data window. */
public class ViewDataButtonPanel extends JToolBar {

private static final long serialVersionUID = 1630693568843700255L;
private Map<String, TwoStateButton> buttons
    = new HashMap<String, TwoStateButton>();

/** Action command of "First Data" button. */
public static final String FIRST = "First Data";
/** Action command of "Previous Data" button. */
public static final String PREVIOUS = "Previous Data";
/** Action command of "Continue/Stop" Loading button. */
public static final String RUNSTOP = "Continue Loading|Stop Loading";
/** Actiom command of "Next Data" button. */
public static final String NEXT = "Next Data";
/** Action command of "Last Data" button. */
public static final String LAST = "Last Data";

/** Needed by IntelliJ's GUI designer. */
public ViewDataButtonPanel() {
    String[] labels = {FIRST, PREVIOUS, RUNSTOP, NEXT, LAST};
    String[] icons = {"first", "prev", "run|stop", "next", "last"};

    setFloatable(false);
    setRollover(true);

    for (int i = 0; i < labels.length; i++) {
        String[] twoLabels = split2(labels[i]);
        String[] twoIcons = split2(icons[i]);
        buttons.put(labels[i], new TwoStateButton(
            labels[i], twoLabels[0], twoLabels[1],
            createIcon(twoIcons[0]), createIcon(twoIcons[1])
        ));
        add(buttons.get(labels[i]));
    }

}

// DUPLICATE OF OTHER CONSTRUCTOR (except line with addActionListener()).
/**
 * Create a toolbar for the view data with an action listener to handle button
 * clicks of the toolbar.
 */
public ViewDataButtonPanel(ActionListener actionListener) {
    String[] labels = {FIRST, PREVIOUS, RUNSTOP, NEXT, LAST};
    String[] icons = {"first", "prev", "run|stop", "next", "last"};

    setFloatable(false);
    setRollover(true);

    for (int i = 0; i < labels.length; i++) {
        String[] twoLabels = split2(labels[i]);
        String[] twoIcons = split2(icons[i]);
        buttons.put(labels[i], new TwoStateButton(
            labels[i], twoLabels[0], twoLabels[1],
            createIcon(twoIcons[0]), createIcon(twoIcons[1])
        ));
        buttons.get(labels[i]).addActionListener(actionListener);
        add(buttons.get(labels[i]));
    }

}

private Icon createIcon(String id) {
    URL resource = getClass().getResource("img/" + id + ".png");
    if (resource == null) resource = getClass().getResource("img/null.png");
    return new ImageIcon(resource);
}

/** Add an action listener to the buttons in the toolbar. */
public void addActionListener(ActionListener actionListener) {
    for (JButton button : buttons.values())
        button.addActionListener(actionListener);
}

/** Enable/Disable a button with key. */
public void setEnabled(String key, boolean enabled) {
    if (buttons.containsKey(key)) buttons.get(key).setEnabled(enabled);
}

/** Set state of a two-state button with key. */
public void setState(String key, boolean state) {
    if (buttons.containsKey(key)) buttons.get(key).setState(state);
}

/** Get state of a two-state button with key. */
public boolean getState(String key) {
    return buttons.get(key).getState();
}

/** Toggle state of a two-state button with key. */
public void toggle(String key) {
    if (buttons.containsKey(key)) buttons.get(key).toggle();
}

// Split a string in two at |. If there is no |, the second string is null
private String[] split2(String s) {
    String[] split = s.split("\\|", 2);

    return split.length == 2 ? split : new String[] {s, null};
}

}
