/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.app.gui.table;

import javax.swing.AbstractCellEditor;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.table.TableCellEditor;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.FocusListener;
import java.awt.event.FocusEvent;
import java.awt.Component;
import java.awt.Color;

/** Cell editor for colors with a color-chooser for cells in tables. */
public class ColorCellEditor extends AbstractCellEditor
    implements TableCellEditor, ActionListener, FocusListener {

private static final long serialVersionUID = -5947558823233265730L;
private JButton button = new JButton();
private JColorChooser colorChooser = new JColorChooser();
private JDialog dialog = JColorChooser.createDialog(
    button, "s A c E s  ::  Pick a color", true, colorChooser, this, null);
private Color color;

public ColorCellEditor() {
    button.addActionListener(this);
    button.addFocusListener(this);
    button.setBorderPainted(false);
}

public Object getCellEditorValue() {
    return color;
}

public Component getTableCellEditorComponent(
    JTable table, Object value, boolean isSelected, int row, int column
) {
    color = (Color)value;
    return button;
}

public void actionPerformed(ActionEvent e) {
    if (e.getSource() == button) {
        button.setBackground(color);
        colorChooser.setColor(color);
        dialog.setVisible(true);
        fireEditingStopped();
    }
    else {
        color = colorChooser.getColor();
    }
}

public void focusGained(FocusEvent e) {
    actionPerformed(new ActionEvent(e.getSource(), e.getID(), ""));
}

public void focusLost(FocusEvent e) {
}

}
