/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.app.gui.table;

import saces.app.gui.ColorField;
import saces.app.gui.ParticleClassesTableModel;

import javax.swing.table.TableCellRenderer;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.border.LineBorder;
import java.awt.Component;


/** Cell renderer that displays color in cells in tables. */
public class ColorCellRenderer implements TableCellRenderer {

private final ColorField cf = new ColorField(true);
private final String focusKey = "Table.focusCellHighlightBorder";
private final ParticleClassesTableModel pctm;

public ColorCellRenderer(ParticleClassesTableModel pctm) {
    this.pctm = pctm;
}

public Component getTableCellRendererComponent(
    JTable table, Object value, boolean isSelected,
    boolean hasFocus, int row, int column
) {
    cf.setColor(pctm.getParticleClasses().get(row).getColor());
    cf.setBorder(hasFocus ? UIManager.getBorder(focusKey)
        : new LineBorder(table.getBackground(), 2));
    return cf;
}

}
