package saces.exp;

/**
 * Is thrown if some internal error in an experiment occurred. Examples are
 * trying to register reactions for already sealed particle classes, giving the
 * wrong number of reagents to reactions (like 4 for decay reactions) etc.
 */
public class ExperimentInvalidException extends RuntimeException {

/** Create an ExperimentInvalidException with an end-user understandable
 * message.
 * @param msg an end-user understandable message.
 */
ExperimentInvalidException(String msg) { super(msg); }
}
