/*
 *                       s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */

package saces.gl;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLU;

/**
 *
 * The DisplayListElement interface is used by objects which are to be
 * drawn by precompiled gl display lists. This interface is passed to
 * the add and call methods of a DisplayList object.
 *
 */
public interface DisplayListElement {

/*  displayMethod
*
*    The displayMethod is the body of code which is to
*    be compiled and stored as a display list by gl.
*    Its implementation should contain the gl routines
*    necessary to draw the object implementing this interface.
*
*      @param gl : GL
*      @param glu : GLU
*
*/

public void displayMethod(GL gl, GLU glu);

/*  setKey
 *
 *    sets the display list key. The display list key
 *    can be used by the DisplyList::call method to map
 *    the display list to the caller.
 *
 *    @param key
 */
public void setKey(int key);

/*  getKey
 *
 *    returns the display list key. The display list key
 *    can be used by the DisplyList::call method to map
 *    the display list to the caller.
 *
 *    @return key
 */
public int getKey();

/*  getDisplayListName
 *
 *    returns the display list name. The display list name
 *    can be used by the DisplyList::call method to map
 *    the display list to the caller.
 *
 *    @return key
 */
public String getDisplayListName();

/*  setDiaplayListName
 *
 *    sets the display list name. The display list name
 *    can be used by the DisplyList::call method to map
 *    the display list to the caller.
 *
 *    @param key
 */
public void setDiaplayListName(String str);

}
