package saces.gl;

/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */

import net.java.games.jogl.GLDrawable;



/**
 *
 * saces.gl.Drawable defines a common GL object. Abstracting GL objects
 * enables the mediator to treat various implementations 
 * of a GL object in the same fashion. The purpose of a GL object
 * interface is to hide the actual geometry and behaviour of
 * the object from the mediator. This encourages a very loose
 * coupling between mediator and the GL Object. Transformation of the
 * object is separated from the drawing method to enable objects implementing
 * the DisplayListElement interface to be placed in a display list. The static
 * part (drawing) are compiled to the display list, while the dynamic part
 * (transformations) are executed in immediate mode.
 * 
 */
public interface Drawable
{

/**
*
*   draw the object or group of objects on glDrawable.
*
*   @param glDrawable : GLDrawable
*
*/
public void draw(GLDrawable glDrawable) ;

/**
*
*   object transformations are implemented here
*
*   @param glDrawable : GLDrawable
*
*/
public void transform(GLDrawable glDrawable) ;


}
