/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.pnp;

import saces.sim.Particle;
import saces.sim.Simulation;


/** The decayer decays particles spontaneously (if they have decay reactions). */
public interface Decayer {

/** A simulation property key for the number of decays in an iteration. */
public final String DECAY_COUNT = "DecayCount";

/**
 * The method to be implemented for Decayers.
 * <p/>
 * <i>in:</i> particle array and simulation<br> <i>simulation out:</i>removed
 * and created particles.
 */
public void decay(Particle[] particles, Simulation simulation);

}
