/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.pnp;

import saces.sim.Particle;
import saces.sim.Collision;
import saces.sim.Simulation;

import java.util.LinkedList;
import java.util.List;


/**
 * A simple collision detection algorithm which works in quadratic time. It
 * compares every particle with every other and calls Particle.overlaps(). This
 * corresponds to calculate a triangle matrix of distances between the
 * particles. For N particles we have N (N-1) / 2 calculations.
 */
public class DetectorSimple implements Detector {

public Collision[] detect(
    Particle[] particles, Simulation simulation
) {
    List<Collision> collisions = new LinkedList<Collision>();

    for (int i = 0; i < particles.length; i++)
        for (int j = i + 1; j < particles.length; j++)
            if (particles[i].overlaps(particles[j]))
                collisions.add(
                    new Collision(particles[i], particles[j]));

    int count = collisions.size();
    return collisions.toArray(new Collision[count]);
}

}
