/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.pnp;

import saces.sim.Particle;
import saces.sim.Simulation;


/**
 * A Reflector reflects particles at the walls. A reflection strategy could be
 * heating or cooling or a rough wall (random reflection angle). Another
 * application is measuring wall pressure and storing them in a simulation
 * property.
 */
public interface Reflector {

/**
 * Reflect all particles outside the experiment box. Additional strategies are
 * allowed but an invariant makes sense: No particle ever touches a box wall or
 * even penetrates it after reflect() returned.
 * <p/>
 * <i>in</i>: particle array and simulation <br> <i>out</i>: particle array
 * (with same particles but with <i>updated</i> data)
 */
public void reflect(Particle[] particles, Simulation simulation);

}
