/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.pnp;

import saces.sim.Particle;
import static saces.Util.X;
import static saces.Util.Y;
import static saces.Util.Z;
import saces.sim.Simulation;


/** Just reflect at the box walls. Nothing fancy is done. */
public class ReflectorSimple implements Reflector {

// a hot spot
public void reflect(Particle[] particles, Simulation simulation) {
    for (Particle particle : particles) {
        float r = particle.radius;
        float r2 = 2*r;
        float[] p = particle.position;
        float[] v = particle.velocity;
        float[] b = simulation.cache.bounds;

        // Invert velocity and position if reflected.
        // Simple and surprisingly reliable. Works even for very large
        // time steps.
        if (p[X] + r > b[X])   { v[X] = -v[X]; p[X] = 2*b[X] - r2 -p[X];  }
        else if (p[X] - r < 0) { v[X] = -v[X]; p[X] = r2 - p[X]; }
        if (p[Y] + r > b[Y])   { v[Y] = -v[Y]; p[Y] = 2*b[Y] - r2 -p[Y];  }
        else if (p[Y] - r < 0) { v[Y] = -v[Y]; p[Y] = r2 - p[Y]; }
        if (p[Z] + r > b[Z])   { v[Z] = -v[Z]; p[Z] = 2*b[Z] - r2 -p[Z];  }
        else if (p[Z] - r < 0) { v[Z] = -v[Z]; p[Z] = r2 - p[Z]; }
    }
}
}
