/*
 *                        s a c e s
 *      Simple Artificial Chemistry Experiment System
 *
 * A semester project Summer 2005 and a diploma project 2006
 *           Berne University of Applied Sciences
 *   HTI School of Engineering and Information Technology
 *             Anthony Aguillon, Daniel Noelpp
 *
 */
package saces.pnp;

import saces.sim.Collision;
import saces.sim.Simulation;


/**
 * Do chemical transform reactions of the form
 * <pre>Product1 + Educt2 -> Product1 + Product2</pre>.
 * Bound energy difference and educt masses are saved in the collision properties.
 */
public interface Transformer {

public static final String TRANSFORM_COUNT = "TransformCount";

/**
 * Transform some collision pairs to prepare them for the collision response (by
 * adding product particles and bound energy difference)
 * <p/>
 * <i>in:</i> collision pair array and simulation<br> <i>out:</i> collision pair
 * arrays with more information for {@linkplain Response#response(saces.sim.Collision[],
 * saces.sim.Simulation)}.
 *
 * @param collisions
 * @param simulation
 */
public void transform(Collision[] collisions, Simulation simulation);

}
