package saces.sim;

import java.util.Collection;
import java.util.HashSet;


/**
 * A helper class for partitionized collision detection. The reaction vessel
 * cuboid is subdivided equally into smaller cuboids, the partition. Every
 * partition has a list of particles currently inside a partition and every
 * particle knows in which partition it is in currently.
 */
public class Partition {

public static final int INITIAL_CAPACITY = 50;

/** The x-index of the partition. */
public final int ix;
/** The y-index of the partition. */
public final int iy;
/** The z-index of the partition. */
public final int iz;
/** The simulation of the partition. */
public final Simulation simulation;
/** The list of particles currently in the partition. */
public final Collection<Particle> particles = new HashSet<Particle>();

/** Create Partition at the indizes ix, iy, iz for the simulation. */
public Partition(int ix, int iy, int iz, Simulation simulation) {
    this.ix = ix;
    this.iy = iy;
    this.iz = iz;
    this.simulation = simulation;
}

}
