package saces.sim;

/**
 * Thrown if there was a problem with the Simulation Plug-and-Play architecture.
 * If thrown, a user message has been shown already. These problems are usually
 * caused by a misconfiguration by the user. An example is if the reaction
 * vessel is too small so that not all particles have place inside it. Then the
 * Distributor will throw an IllegalArgumentException which is catched, an error
 * message shown and rethrown as this exception.
 */
public class SimulationPNPException extends RuntimeException {

public SimulationPNPException(Throwable cause) {
    super(cause);
}

}
